<?php
// $Id:$
/**
 * @file
 * BeeColony user data management functions.
 */


/******************************
 * Services Callback Functions.
 ******************************/

/**
 * Get ubercart orders for user.
 * 
 * Get all ubercart orders from database for a single user
 * and return them as an associative array.
 * 
 * @return struct
 *   Associative array with orders data.
 */
function xmls_bee_colony_user_list_orders() {
  $orders = array();
  $order_query = db_query("SELECT order_id, order_total, created, product_count FROM {uc_orders} WHERE uid = %d", $GLOBALS['user']->uid);  //Pick up from database orders for logged user.
  while ($row_order = db_fetch_array($order_query)) {  //Building of object
    $orders[$row_order['order_id']] = $row_order;
  }
  if (!empty($orders)) return $orders;
  else return services_error(t("There are no orders."));
}

/**
 * Get details of ubercart order for user.
 * 
 * Get all ubercart orders from database for a single user
 * and return them as an associative array.
 * 
 * @return struct
 *   Associative array with orders data.
 */
function xmls_bee_colony_user_get_order($id) {
  $order = uc_order_load($id);
  if ($order->uid == $GLOBALS['user']->uid) return $order;
  if ($order->uid != $GLOBALS['user']->uid) return services_error(t("You cannot load other users orders."));
  else return services_error(t("Order #%d does not exist.", array('%d' => $id)));
}

/**
 * Create a new order.
 * 
 * @return struct
 *   Associative array with created order data.
 */
function xmls_bee_colony_user_new_order($order) {
  $return = array();
  $return['order'] = $order;
  $insert = uc_order_new($GLOBALS['user']->uid);
  foreach ($order as $key => $value) {
    if (($key != 'products') && ($key != 'order_id') && ($key != 'status')) $insert->$key = $value;
  }
  $insert->status = 'pending';
  foreach ($order['products'] as $key => $value) {
  	$insert->products[$key] = (object)$value;
  }
  $return['insert'] = $insert;
  uc_order_save($insert);
  return $return;
}